=== externals/Makefile ===
SUBDIRS = numrec
TOP=../

include $(TOP)/unix_tools/make.rules
