=== externals/numrec/Makefile ===
SOURCES = numrecipes_fft.c
MODULES = $(SOURCES:%.c=%.o)

TOP=../..

include $(TOP)/unix_tools/make.rules
