=== debian/changelog ===
clam (1.4.0-7) unstable; urgency=medium

  * Team upload.
  * Rename libclam1.4 for GCC 5 transition.
  * debian/control:
    - Bump Standards-Version.
    - Update Vcs-* fields.
    - Remove extra Section.
    - Remove extra ${python:Depends}.
  * debian/{libclam1.4.dirs,docs}: Remove, no longer needed.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 12 Aug 2015 16:43:52 +0200

clam (1.4.0-6) unstable; urgency=medium

  * Team upload.
  * Link against libvorbis and libogg to fix FTBFS (Closes: #769213)

 -- James Cowgill <james410@cowgill.org.uk>  Fri, 21 Nov 2014 16:47:36 +0000

clam (1.4.0-5.2) unstable; urgency=low

  * Non maintainer upload
  * Fix FTBFS: TIME_UTC compilation error (Closes: #701257)
  * Fix FTBFS: gcc 4.8 template expansion error
  * Support Xerces C 3 (Closes: #733071)

 -- Jay Berkenbilt <qjb@debian.org>  Sat, 15 Feb 2014 17:27:09 -0500

clam (1.4.0-5.1) unstable; urgency=low

  * Non maintainer upload
  * Build with -fpermissive. Closes: #667136.

 -- Matthias Klose <doko@debian.org>  Tue, 29 May 2012 04:29:23 +0000

clam (1.4.0-5) unstable; urgency=low

  [ Adrian Knoth ]
  * Build-Depend on libjack-dev only
  * Provide Vcs fields in debian/control

  [ TANIGUCHI Takaki ]
  * debian/control: remove libjack-jack2-dev from BD. (Closes: #626989)

 -- TANIGUCHI Takaki <takaki@debian.org>  Tue, 17 May 2011 08:58:01 +0900

clam (1.4.0-4) unstable; urgency=low

  * debian/control: add libjack-dev to Build-depends. (Closes: #626303)

 -- TANIGUCHI Takaki <takaki@debian.org>  Mon, 16 May 2011 21:56:12 +0900

clam (1.4.0-3) unstable; urgency=low

  * debian/control: add libjack-dev to Depends. (Closes: #626303)
  * Bump Standards-Version to 3.9.2 with no changes.
  * debian/patches/ftbfs_NULL: Added. (Closes: #624999)

 -- TANIGUCHI Takaki <takaki@debian.org>  Mon, 16 May 2011 12:18:02 +0900

clam (1.4.0-2) unstable; urgency=low

  * debian/control: add libdevel packages to libclam-dev's Depends.

 -- TANIGUCHI Takaki <takaki@debian.org>  Thu, 07 Apr 2011 10:31:37 +0900

clam (1.4.0-1) unstable; urgency=low

  * Initial release (Closes: #493282)

 -- TANIGUCHI Takaki <takaki@debian.org>  Fri, 04 Feb 2011 11:51:41 +0900
