=== debian/watch ===
version=3
http://clam-project.org/download/src/ CLAM-(.*)\.tar\.gz
